﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace erettsegi02_vigenere
{
    class erettsegi02_vigenere
    {
        static void Main()
        {
            #region 1. feladat: Nyílt szöveg bekérése
            Console.WriteLine("1. Feladat: Kérem a nyílt szöveget");
            string nyiltszoveg="";
            do
              nyiltszoveg=Console.ReadLine();
            while (nyiltszoveg.Length==0 || nyiltszoveg.Length>255);
            #endregion

            #region 2. feladat: Nyílt szöveg átalakítása
            Console.WriteLine("2. Feladat: Nyílt szöveg átalakítása");
            string  mit = "ÍÉÁŰŐÚÖÜÓ";
            string mire = "IEAUOUOUO";

            nyiltszoveg = nyiltszoveg.ToUpper();
            for (int i=0;i<mit.Length;++i) 
                nyiltszoveg= nyiltszoveg.Replace(mit[i],mire[i]);
            
            //Egyéb karakterek törlése
            for (int i = 0; i < nyiltszoveg.Length; )
                if (!Char.IsLetter(nyiltszoveg, i)) 
                    nyiltszoveg=nyiltszoveg.Remove(i, 1); else ++i;
            #endregion

            #region 3. feladat: Nyílt szöveg kiírása
            Console.WriteLine("3. Feladat: Nyílt szöveg kiírása: ");
            Console.WriteLine(nyiltszoveg);
            #endregion

            #region 4. feladat: Kulcs szöveg bekérése
            Console.WriteLine("4. Feladat: Kérem a kulcs szöveget");
            string kulcsszoveg = "";
            do
                kulcsszoveg= Console.ReadLine().ToUpper();
            while (kulcsszoveg.Length == 0 || kulcsszoveg.Length > 5);
            #endregion

            #region 5. feladat: Kulcs szöveg összefűzése
            Console.WriteLine("5. Feladat: Kulcs szöveg összefűzése");
            while (kulcsszoveg.Length < nyiltszoveg.Length)
                kulcsszoveg += kulcsszoveg; //összefűz
            kulcsszoveg=kulcsszoveg.Substring(0, nyiltszoveg.Length); //végét levág, ha kell
            Console.WriteLine("\nAz összefűzött kulcsszöveg: ");
            Console.WriteLine(kulcsszoveg);
            #endregion

            #region 6.feladat: Vigenere tábla beolvasása, kódolás
            Console.WriteLine("6. Feladat: Vigenere tábla beolvasása, kódolás");
            char[,] vt = new char[26, 26]; //26x26-os karakter típusú mátrix

            using (StreamReader sr = new StreamReader(@"Vtabla.dat"))
            {
                string s = "";
                for (int i = 0; i < 26; i++)
                {
                    s = sr.ReadLine();
                    for (int j = 0; j < 26; ++j) vt[i, j] = s[j]; //mátrix feltöltése
                }
            }

            string kodoltszoveg="";
            //"A" unikódja 65
            //'A'-65 -> 0 'B'-65 -> 1
            for (int i = 0; i < nyiltszoveg.Length; ++i) 
                kodoltszoveg+=vt[nyiltszoveg[i]-65,kulcsszoveg[i]-65];

            #endregion

            #region 7.feladat: Kódolt szöveg kiírása (képernyőre és kodol.dat-ba)
            Console.WriteLine("7. Feladat: Kódolt szöveg kiírása (képernyőre és kodol.dat-ba)");
            Console.WriteLine(kodoltszoveg);
            using( StreamWriter sw = new StreamWriter("kodol.dat"))
            {
               sw.WriteLine(kodoltszoveg);
            }
            #endregion

            Console.ReadKey();
      }
    }
}
